diff -Nru --exclude=CVS --exclude=CMakeFiles certi.orig/libCERTI/LBTS.cc certi/libCERTI/LBTS.cc
--- certi.orig/libCERTI/LBTS.cc	2008-12-07 11:39:03.000000000 +0100
+++ certi/libCERTI/LBTS.cc	2008-12-13 03:48:11.000000000 +0100
@@ -122,7 +122,7 @@
 void
 LBTS::update(FederateHandle num_fed, FederationTime time)
 {
-    D.Out(pdDebug, "LBTS.update: Updating federate %d(%f).", num_fed, time);
+    D.Out(pdDebug, "LBTS.update: Updating federate %d(%f).", num_fed, time.getTime());
 
     ClockSet::iterator it = clocks.find(num_fed);
 
@@ -136,10 +136,10 @@
               num_fed);
     else {
         D.Out(pdDebug, "before LBTS.update: federate %u, old time %f.",
-              it->first, it->second);
+              it->first, it->second.getTime());
         it->second = time ;
         D.Out(pdDebug, "after LBTS.update: federate %u, new time %f.",
-              it->first, it->second) ;
+              it->first, it->second.getTime());
         compute();
     }
 }
diff -Nru --exclude=CVS --exclude=CMakeFiles certi.orig/libCERTI/LBTS.hh certi/libCERTI/LBTS.hh
--- certi.orig/libCERTI/LBTS.hh	2007-11-20 10:04:54.000000000 +0100
+++ certi/libCERTI/LBTS.hh	2008-12-13 18:28:36.000000000 +0100
@@ -26,10 +26,11 @@
 #define LIBCERTI_LBTS_HH
 
 #include "certi.hh"
+#include "FedTimeD.hh"
 
 #ifndef _WIN32				
-#include <unistd.h>
-#include <stdlib.h>
+#include <unistd.h>
+#include <stdlib.h>
 #endif
 
 #include <map>
diff -Nru --exclude=CVS --exclude=CMakeFiles certi.orig/libCERTI/Message.cc certi/libCERTI/Message.cc
--- certi.orig/libCERTI/Message.cc	2008-12-07 11:39:03.000000000 +0100
+++ certi/libCERTI/Message.cc	2008-12-13 17:41:21.000000000 +0100
@@ -197,23 +197,23 @@
     @param the_time federation time
 */
 void
-Message::setFedTime(const RTI::FedTime &the_time)
+Message::setFedTime(const double the_time)
 {
-    fed_time = dynamic_cast<const RTIfedTime &>(the_time);
+    fed_time = the_time;
 }
 
 // ----------------------------------------------------------------------------
 void
-Message::setLookahead(const RTI::FedTime& the_lookahead)
+Message::setLookahead(const double the_lookahead)
 {
-    lookahead = (FederationTimeDelta) ((RTIfedTime&) the_lookahead).getTime();
+    lookahead = the_lookahead;
 }
 
 // ----------------------------------------------------------------------------
 void
 Message::setFederationTime(FederationTime the_time)
 {
-    fed_time = RTIfedTime(the_time);
+    fed_time = the_time;
 }
 
 // ----------------------------------------------------------------------------
@@ -238,14 +238,14 @@
 
 // ----------------------------------------------------------------------------
 void
-Message::setTransportation(RTI::TransportationHandle the_transport)
+Message::setTransportation(TransportType the_transport)
 {
     transport = the_transport;
 }
 
 // ----------------------------------------------------------------------------
 void
-Message::setOrdering(RTI::OrderingHandle the_ordering)
+Message::setOrdering(OrderType the_ordering)
 {
     order = the_ordering;
 }
diff -Nru --exclude=CVS --exclude=CMakeFiles certi.orig/libCERTI/Message.hh certi/libCERTI/Message.hh
--- certi.orig/libCERTI/Message.hh	2008-12-07 11:39:03.000000000 +0100
+++ certi/libCERTI/Message.hh	2008-12-13 18:28:33.000000000 +0100
@@ -26,7 +26,7 @@
 #include "SocketUN.hh"
 #include "BasicMessage.hh"
 #include "GAV.hh"
-#include "fedtime.hh"
+#include "FedTimeD.hh"
 
 #include <vector>
 #include <string>
@@ -327,10 +327,10 @@
     void setResignAction(RTI::ResignAction);
     RTI::ResignAction getResignAction() const { return resignAction ; };
 
-    void setFedTime(const RTI::FedTime&);
-    const RTI::FedTime& getFedTime() const { return fed_time; };
+    void setFedTime(const double);
+    double getFedTime() const { return fed_time.getTime(); };
 
-    void setLookahead(const RTI::FedTime&);
+    void setLookahead(const double);
 
     void setFederationTime(FederationTime);
     FederationTime getFederationTime() const { return fed_time.getTime(); };
@@ -341,12 +341,12 @@
     void setObject(ObjectHandle);
     ObjectHandle getObject() const { return object ; };
 
-    void setTransportation(RTI::TransportationHandle);
-    RTI::TransportationHandle getTransportation() const
+    void setTransportation(TransportType);
+    TransportType getTransportation() const
     { return transport; }
 
-    void setOrdering(RTI::OrderingHandle);
-    RTI::OrderingHandle getOrdering() const
+    void setOrdering(OrderType);
+    OrderType getOrdering() const
     { return order; }
 
     void setEventRetraction(EventRetractionHandle);
@@ -389,7 +389,7 @@
     TypeException exception ;
     std::string exceptionReason;
 
-    RTIfedTime fed_time;
+    FedTime fed_time;
     bool boolean ;
     FederationTimeDelta lookahead ;
     FederateHandle federate ;
diff -Nru --exclude=CVS --exclude=CMakeFiles certi.orig/libCERTI/Message_W.cc certi/libCERTI/Message_W.cc
--- certi.orig/libCERTI/Message_W.cc	2008-11-21 15:34:27.000000000 +0100
+++ certi/libCERTI/Message_W.cc	2008-12-13 03:50:03.000000000 +0100
@@ -494,7 +494,7 @@
           case ENABLE_TIME_CONSTRAINED:
           case DISABLE_TIME_CONSTRAINED:
             msgBuffer.write_bool(boolean);
-            msgBuffer.write_double(lookahead);
+            msgBuffer.write_double(lookahead.getTime());
             break ;
 
 	  // Body contains boolean
@@ -527,7 +527,7 @@
           case MODIFY_LOOKAHEAD:
           case QUERY_LOOKAHEAD:
             // we put another time but is the lookahead
-	    msgBuffer.write_double(lookahead) ;
+	    msgBuffer.write_double(lookahead.getTime());
             break ;
             // -- Default Handler --
 
@@ -564,7 +564,7 @@
     // Note sometimes federationTime is not useful.
     msgBuffer.write_int32(this->type) ;
     msgBuffer.write_int32(this->exception);
-    msgBuffer.write_double(getFederationTime());
+    msgBuffer.write_double(getFederationTime().getTime());
 
     // If the message carry an exception, the Body will only contain the
     // exception reason.
diff -Nru --exclude=CVS --exclude=CMakeFiles certi.orig/libCERTI/NetworkMessage.hh certi/libCERTI/NetworkMessage.hh
--- certi.orig/libCERTI/NetworkMessage.hh	2008-11-21 09:46:28.000000000 +0100
+++ certi/libCERTI/NetworkMessage.hh	2008-12-13 18:28:40.000000000 +0100
@@ -23,7 +23,7 @@
 #ifndef CERTI_NETWORK_MESSAGE_HH
 #define CERTI_NETWORK_MESSAGE_HH
 
-#include "fedtime.hh"
+#include "FedTimeD.hh"
 #include "Exception.hh"
 #include "Socket.hh"
 #include "RTIRegion.hh"
diff -Nru --exclude=CVS --exclude=CMakeFiles certi.orig/libCERTI/NetworkMessage_RW.cc certi/libCERTI/NetworkMessage_RW.cc
--- certi.orig/libCERTI/NetworkMessage_RW.cc	2008-10-22 14:43:08.000000000 +0200
+++ certi/libCERTI/NetworkMessage_RW.cc	2008-12-13 03:58:37.000000000 +0100
@@ -18,6 +18,7 @@
 //
 // $Id: NetworkMessage_RW.cc,v 3.52 2008/10/23 13:46:19 erk Exp $
 // ----------------------------------------------------------------------------
+
 #include "NetworkMessage.hh"
 #include "PrettyDebug.hh"
 
@@ -53,8 +54,8 @@
 	 */
 	msgBuffer.write_bool(_isDated);
 	if (_isDated) {
-		msgBuffer.write_double(date);
-		D.Out(pdDebug, "Sent Message date is  <%f>", date);
+		msgBuffer.write_double(date.getTime());
+		D.Out(pdDebug, "Sent Message date is  <%f>", date.getTime());
 	}
 	msgBuffer.write_bool(_isLabelled);
 	if (_isLabelled) {
@@ -74,8 +75,8 @@
 	 */
 	D[pdDebug] << "Deserialize <" << getName().c_str()<<">"<<endl;
 	/* deserialize common part */
-	type        = static_cast<certi::NetworkMessage::Type>(msgBuffer.read_int32());
-	exception   = static_cast<certi::TypeException>(msgBuffer.read_int32());
+	type        = static_cast<NetworkMessage::Type>(msgBuffer.read_int32());
+	exception   = static_cast<TypeException>(msgBuffer.read_int32());
 	federate    = msgBuffer.read_int32();
 	federation  = msgBuffer.read_int32();
 	/*
@@ -87,7 +88,7 @@
 	_isDated = msgBuffer.read_bool();
 	if (_isDated) {
 		date = msgBuffer.read_double();
-		D.Out(pdDebug, "Received Message date is  <%f>", date);
+		D.Out(pdDebug, "Received Message date is  <%f>", date.getTime());
 	}
 	_isLabelled = msgBuffer.read_bool();
 	if (_isLabelled) {
diff -Nru --exclude=CVS --exclude=CMakeFiles certi.orig/libRTI/CMakeLists.txt certi/libRTI/CMakeLists.txt
--- certi.orig/libRTI/CMakeLists.txt	2008-12-07 11:39:03.000000000 +0100
+++ certi/libRTI/CMakeLists.txt	2008-12-13 06:14:04.000000000 +0100
@@ -31,7 +31,44 @@
             DESTINATION lib)
 ENDIF (MINGW)
 
-INSTALL(TARGETS RTI
+##################################################################
+# Lib FedTime 
+# A replacement lib FedTime may be provided by the user
+# CERTI is provided one. The lib FedTime depends on libRTI
+# since it inherits from the RTI::FedTime abstract class.
+##################################################################
+IF(CMAKE_COMPILER_IS_GNUCC)
+    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-long-long")
+ENDIF(CMAKE_COMPILER_IS_GNUCC)
+IF(CMAKE_COMPILER_IS_GNUCXX)
+    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-long-long")
+ENDIF(CMAKE_COMPILER_IS_GNUCXX)
+
+INCLUDE_DIRECTORIES(../libHLA)
+SET(FEDTIME_SRCS
+    RTIfedTime.cc
+    ${CMAKE_SOURCE_DIR}/include/fedtime.hh
+)
+
+SOURCE_GROUP("Source Files\\FedTime" FILES ${FEDTIME_SRCS})
+
+ADD_LIBRARY(FedTime
+    ${FEDTIME_SRCS}
+)
+
+TARGET_LINK_LIBRARIES(FedTime RTI HLA)
+
+SET_TARGET_PROPERTIES(FedTime PROPERTIES PROJECT_LABEL LibFedTime)
+IF (MINGW)
+    SET_TARGET_PROPERTIES(FedTime PROPERTIES LINK_FLAGS "-Wl,--output-def,${LIBRARY_OUTPUT_PATH}/libFedTime.def")
+    INSTALL(FILES ${LIBRARY_OUTPUT_PATH}/libFedTime.def
+            DESTINATION lib)
+ENDIF (MINGW)
+
+SET_TARGET_PROPERTIES(FedTime PROPERTIES VERSION 1.0.0 SOVERSION 1)
+
+# Install rules for both libRTI-NG and libFedTime
+INSTALL(TARGETS RTI FedTime
     RUNTIME DESTINATION bin
     LIBRARY DESTINATION lib
     ARCHIVE DESTINATION lib)
diff -Nru --exclude=CVS --exclude=CMakeFiles certi.orig/libRTI/RTIambassador.cc certi/libRTI/RTIambassador.cc
--- certi.orig/libRTI/RTIambassador.cc	2008-12-07 11:39:03.000000000 +0100
+++ certi/libRTI/RTIambassador.cc	2008-12-13 18:04:19.000000000 +0100
@@ -22,8 +22,8 @@
 // $Id: RTIambassador.cc,v 3.101 2008/12/07 20:16:16 gotthardp Exp $
 // ----------------------------------------------------------------------------
 
-
-#include "certi.hh"
+#include "RTI.hh"
+#include "fedtime.hh"
 
 #include "RTIambPrivateRefs.hh"
 #include "RTItypesImp.hh"
@@ -612,7 +612,7 @@
 //! Request Federation Save with time.
 void
 RTI::RTIambassador::requestFederationSave(const char *label,
-                                     const FedTime& theTime)
+                                     const RTI::FedTime& theTime)
     throw (RTI::FederationTimeAlreadyPassed,
            RTI::InvalidFederationTime,
            RTI::FederateNotExecutionMember,
@@ -626,7 +626,7 @@
     G.Out(pdGendoc,"enter RTIambassador::requestFederationSave with time");
 
     req.type = Message::REQUEST_FEDERATION_SAVE ;
-    req.setFedTime(theTime);
+    req.setFedTime(cast<RTIfedTime>()(theTime).getTime());
     req.setLabel(label);
     // boolean true means time constrained
     req.setBoolean(true);
@@ -975,11 +975,11 @@
     @param theTime       Federation time
     @param theTag        User supplied tag
 */
-EventRetractionHandle
+RTI::EventRetractionHandle
 RTI::RTIambassador::
 updateAttributeValues(ObjectHandle theObject,
                       const AttributeHandleValuePairSet& theAttributes,
-                      const FedTime& theTime,
+                      const RTI::FedTime& theTime,
                       const char *theTag)
     throw (RTI::ObjectNotKnown,
            RTI::AttributeNotDefined,
@@ -996,7 +996,7 @@
 
     req.type = Message::UPDATE_ATTRIBUTE_VALUES ;
     req.setObject(theObject);
-    req.setFedTime(theTime);
+    req.setFedTime(cast<RTIfedTime>()(theTime).getTime());
     if ( theTag == NULL)
        {
        throw RTI::RTIinternalError ("Calling updateAttributeValues with Tag NULL");
@@ -1054,10 +1054,10 @@
     @param theTime Federation time
     @param theTag User-supplied tag
 */
-EventRetractionHandle
+RTI::EventRetractionHandle
 RTI::RTIambassador::sendInteraction(InteractionClassHandle theInteraction,
                                const ParameterHandleValuePairSet& theParameters,
-                               const FedTime& theTime,
+                               const RTI::FedTime& theTime,
                                const char *theTag)
     throw (RTI::InteractionClassNotDefined,
            RTI::InteractionClassNotPublished,
@@ -1073,7 +1073,7 @@
 
     req.type = Message::SEND_INTERACTION ;
     req.setInteractionClass(theInteraction);
-    req.setFedTime(theTime);
+    req.setFedTime(cast<RTIfedTime>()(theTime).getTime());
     if (theTag == NULL)
        {
        throw RTI::RTIinternalError ("Calling sendInteraction with Tag NULL") ;
@@ -1130,9 +1130,9 @@
     @param theTime Federation time
     @param theTag user supplied tag
 */
-EventRetractionHandle
+RTI::EventRetractionHandle
 RTI::RTIambassador::deleteObjectInstance(ObjectHandle theObject,
-                                    const FedTime& theTime,
+                                    const RTI::FedTime& theTime,
                                     const char *theTag)
     throw (RTI::ObjectNotKnown,
            RTI::DeletePrivilegeNotHeld,
@@ -1147,7 +1147,7 @@
 
     req.type = Message::DELETE_OBJECT_INSTANCE ;
     req.setObject(theObject);
-    req.setFedTime(theTime);
+    req.setFedTime(cast<RTIfedTime>()(theTime).getTime());
     if (theTag == NULL)
        {
        throw RTI::RTIinternalError ("Calling deleteObjectInstance with Tag NULL") ;
@@ -1531,8 +1531,8 @@
 // ----------------------------------------------------------------------------
 // Enable Time Regulation
 void
-RTI::RTIambassador::enableTimeRegulation(const FedTime& theFederateTime,
-                                    const FedTime& theLookahead)
+RTI::RTIambassador::enableTimeRegulation(const RTI::FedTime& theFederateTime,
+                                    const RTI::FedTime& theLookahead)
     throw (RTI::RTIinternalError, RTI::RestoreInProgress, 
 	   RTI::SaveInProgress, RTI::FederateNotExecutionMember, 
 	   RTI::ConcurrentAccessAttempted, RTI::InvalidLookahead, 
@@ -1541,8 +1541,8 @@
 {
     Message req, rep ;
     req.type = Message::ENABLE_TIME_REGULATION ;
-    req.setFedTime(theFederateTime);
-    req.setLookahead(theLookahead);
+    req.setFedTime(cast<RTIfedTime>()(theFederateTime).getTime());
+    req.setLookahead(cast<RTIfedTime>()(theLookahead).getTime());
     req.setBoolean(true);
     privateRefs->executeService(&req, &rep);
 }
@@ -1603,7 +1603,7 @@
 // ----------------------------------------------------------------------------
 // Time Advance Request
 void
-RTI::RTIambassador::timeAdvanceRequest(const FedTime& theTime)
+RTI::RTIambassador::timeAdvanceRequest(const RTI::FedTime& theTime)
     throw (RTI::TimeAdvanceAlreadyInProgress,
            RTI::FederationTimeAlreadyPassed,
            RTI::InvalidFederationTime,
@@ -1618,14 +1618,14 @@
     Message req, rep ;
 
     req.type = Message::TIME_ADVANCE_REQUEST ;
-    req.setFedTime(theTime);
+    req.setFedTime(cast<RTIfedTime>()(theTime).getTime());
     privateRefs->executeService(&req, &rep);
 }
 
 // ----------------------------------------------------------------------------
 // Time Advance Request Available
 void
-RTI::RTIambassador::timeAdvanceRequestAvailable(const FedTime& theTime)
+RTI::RTIambassador::timeAdvanceRequestAvailable(const RTI::FedTime& theTime)
     throw (RTI::RTIinternalError, RTI::RestoreInProgress, RTI::SaveInProgress, 
 	   RTI::ConcurrentAccessAttempted, RTI::FederateNotExecutionMember, 
 	   RTI::EnableTimeConstrainedPending, RTI::EnableTimeRegulationPending, 
@@ -1635,7 +1635,7 @@
     Message req, rep ;
 
     req.type = Message::TIME_ADVANCE_REQUEST_AVAILABLE ;
-    req.setFedTime(theTime);
+    req.setFedTime(cast<RTIfedTime>()(theTime).getTime());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -1643,7 +1643,7 @@
 // ----------------------------------------------------------------------------
 // Next Event Request
 void
-RTI::RTIambassador::nextEventRequest(const FedTime& theTime)
+RTI::RTIambassador::nextEventRequest(const RTI::FedTime& theTime)
     throw (RTI::TimeAdvanceAlreadyInProgress,
            RTI::FederationTimeAlreadyPassed,
            RTI::InvalidFederationTime,
@@ -1658,14 +1658,14 @@
     Message req, rep ;
 
     req.type = Message::NEXT_EVENT_REQUEST ;
-    req.setFedTime(theTime);
+    req.setFedTime(cast<RTIfedTime>()(theTime).getTime());
     privateRefs->executeService(&req, &rep);
 }
 
 // ----------------------------------------------------------------------------
 // Next Event Request Available
 void
-RTI::RTIambassador::nextEventRequestAvailable(const FedTime& theTime)
+RTI::RTIambassador::nextEventRequestAvailable(const RTI::FedTime& theTime)
     throw (RTI::RTIinternalError, RTI::RestoreInProgress, RTI::SaveInProgress, 
 	   RTI::ConcurrentAccessAttempted, RTI::FederateNotExecutionMember, 
 	   RTI::EnableTimeConstrainedPending, RTI::EnableTimeRegulationPending, 
@@ -1675,14 +1675,14 @@
     Message req, rep ;
 
     req.type = Message::NEXT_EVENT_REQUEST_AVAILABLE ;
-    req.setFedTime(theTime);
+    req.setFedTime(cast<RTIfedTime>()(theTime).getTime());
     privateRefs->executeService(&req, &rep);
 }
 
 // ----------------------------------------------------------------------------
 // Flush Queue Request
 void
-RTI::RTIambassador::flushQueueRequest(const FedTime& theTime)
+RTI::RTIambassador::flushQueueRequest(const RTI::FedTime& theTime)
     throw (RTI::TimeAdvanceAlreadyInProgress,
            RTI::FederationTimeAlreadyPassed,
            RTI::InvalidFederationTime,
@@ -1698,7 +1698,7 @@
     Message req, rep ;
 
     req.type = Message::FLUSH_QUEUE_REQUEST ;
-    req.setFedTime(theTime);
+    req.setFedTime(cast<RTIfedTime>()(theTime).getTime());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -1738,7 +1738,7 @@
 // ----------------------------------------------------------------------------
 // Query LBTS
 void
-RTI::RTIambassador::queryLBTS(FedTime& theTime)
+RTI::RTIambassador::queryLBTS(RTI::FedTime& theTime)
     throw (RTI::FederateNotExecutionMember,
            RTI::ConcurrentAccessAttempted,
            RTI::SaveInProgress,
@@ -1750,13 +1750,13 @@
     req.type = Message::QUERY_LBTS ;
     privateRefs->executeService(&req, &rep);
 
-    theTime = rep.getFedTime();
+    cast<RTIfedTime>()(theTime) = rep.getFedTime();
 }
 
 // ----------------------------------------------------------------------------
 // Query Federate Time
 void
-RTI::RTIambassador::queryFederateTime(FedTime& theTime)
+RTI::RTIambassador::queryFederateTime(RTI::FedTime& theTime)
     throw (RTI::FederateNotExecutionMember,
            RTI::ConcurrentAccessAttempted,
            RTI::SaveInProgress,
@@ -1768,13 +1768,13 @@
     req.type = Message::QUERY_FEDERATE_TIME ;
     privateRefs->executeService(&req, &rep);
 
-    theTime = rep.getFedTime();
+    cast<RTIfedTime>()(theTime) = rep.getFedTime();
 }
 
 // ----------------------------------------------------------------------------
 // Query Minimum Next Event Time
 void
-RTI::RTIambassador::queryMinNextEventTime(FedTime& theTime)
+RTI::RTIambassador::queryMinNextEventTime(RTI::FedTime& theTime)
     throw (RTI::FederateNotExecutionMember,
            RTI::ConcurrentAccessAttempted,
            RTI::SaveInProgress,
@@ -1786,13 +1786,13 @@
     req.type = Message::QUERY_MIN_NEXT_EVENT_TIME ;
     privateRefs->executeService(&req, &rep);
 
-    theTime = rep.getFedTime();
+    cast<RTIfedTime>()(theTime) = rep.getFedTime();
 }
 
 // ----------------------------------------------------------------------------
 // Modify Lookahead
 void
-RTI::RTIambassador::modifyLookahead(const FedTime& theLookahead)
+RTI::RTIambassador::modifyLookahead(const RTI::FedTime& theLookahead)
     throw (RTI::RTIinternalError, RTI::RestoreInProgress, RTI::SaveInProgress, 
 	   RTI::ConcurrentAccessAttempted, RTI::FederateNotExecutionMember, 
 	   RTI::InvalidLookahead)
@@ -1800,7 +1800,7 @@
     Message req, rep ;
 
     req.type = Message::MODIFY_LOOKAHEAD ;
-    req.setLookahead(theLookahead);
+    req.setLookahead(cast<RTIfedTime>()(theLookahead).getTime());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -1808,7 +1808,7 @@
 // ----------------------------------------------------------------------------
 // Query Lookahead
 void
-RTI::RTIambassador::queryLookahead(FedTime &theTime)
+RTI::RTIambassador::queryLookahead(RTI::FedTime &theTime)
     throw (RTI::FederateNotExecutionMember,
            RTI::ConcurrentAccessAttempted,
            RTI::SaveInProgress,
@@ -1820,19 +1820,13 @@
     req.type = Message::QUERY_LOOKAHEAD ;
     privateRefs->executeService(&req, &rep);
 
-    try { 
-        RTIfedTime &ret = dynamic_cast<RTIfedTime&>(theTime); 
-        ret = RTIfedTime((Double) rep.getFederationTimeDelta());
-    }
-    catch (std::bad_cast) {
-	throw RTI::RTIinternalError("theTime is not a RTIfedTime object");
-    }
+    cast<RTIfedTime>()(theTime) = rep.getFederationTimeDelta().getTime();
 }
 
 // ----------------------------------------------------------------------------
 // Retract
 void
-RTI::RTIambassador::retract(EventRetractionHandle handle)
+RTI::RTIambassador::retract(RTI::EventRetractionHandle handle)
     throw (RTI::RTIinternalError, RTI::RestoreInProgress, RTI::SaveInProgress, 
 	   RTI::ConcurrentAccessAttempted, RTI::FederateNotExecutionMember, 
 	   RTI::InvalidRetractionHandle)
@@ -2234,10 +2228,10 @@
 
 // ----------------------------------------------------------------------------
 // Send Interaction With Region
-EventRetractionHandle
+RTI::EventRetractionHandle
 RTI::RTIambassador::sendInteractionWithRegion(InteractionClassHandle interaction,
                                          const ParameterHandleValuePairSet &par,
-                                         const FedTime &time,
+                                         const RTI::FedTime &time,
                                          const char *tag,
                                          const Region &region)
     throw (RTI::InteractionClassNotDefined,
@@ -2257,7 +2251,7 @@
     req.setType(Message::SEND_INTERACTION);
     req.setInteractionClass(interaction);
     req.setPHVPS(cast<ParameterHandleValuePairSetImp>()(par).getParameterHandleValuePairs());
-    req.setFedTime(time);
+    req.setFedTime(cast<RTIfedTime>()(time).getTime());
     if ( tag == NULL )
        {
        throw RTI::RTIinternalError ("Calling sendInteractionWithRegion with Tag NULL");
diff -Nru --exclude=CVS --exclude=CMakeFiles certi.orig/libRTI/RTIambPrivateRefs.cc certi/libRTI/RTIambPrivateRefs.cc
--- certi.orig/libRTI/RTIambPrivateRefs.cc	2008-12-07 11:39:03.000000000 +0100
+++ certi/libRTI/RTIambPrivateRefs.cc	2008-12-13 07:40:10.000000000 +0100
@@ -712,7 +712,7 @@
             if (msg->getBoolean())
                fed_amb->reflectAttributeValues(msg->getObject(),
                                                *attributes,
-                                               msg->getFedTime(),
+                                               RTIfedTime(msg->getFedTime()),
                                                (msg->getTag()).c_str(),
                                                msg->getEventRetraction());
             else
@@ -733,7 +733,7 @@
                 fed_amb->receiveInteraction(
                                         msg->getInteractionClass(),
                                         *parameters,
-                                        msg->getFedTime(),
+                                        RTIfedTime(msg->getFedTime()),
                                         (msg->getTag()).c_str(),
                                         msg->getEventRetraction());
             else
@@ -752,7 +752,7 @@
             if (msg->getBoolean()) {
                 fed_amb->removeObjectInstance(
                                           msg->getObject(),
-                                          msg->getFedTime(),
+                                          RTIfedTime(msg->getFedTime()),
                                           (msg->getTag()).c_str(),
                                           msg->getEventRetraction());
             }
@@ -884,21 +884,21 @@
 
       case Message::TIME_ADVANCE_GRANT:
         try {
-            fed_amb->timeAdvanceGrant(msg->getFedTime());
+            fed_amb->timeAdvanceGrant(RTIfedTime(msg->getFedTime()));
         }
         CATCH_FEDERATE_AMBASSADOR_EXCEPTIONS("timeAdvanceGrant")
         break ;
 
       case Message::TIME_REGULATION_ENABLED:
         try {
-            fed_amb->timeRegulationEnabled(msg->getFedTime());
+            fed_amb->timeRegulationEnabled(RTIfedTime(msg->getFedTime()));
         }
         CATCH_FEDERATE_AMBASSADOR_EXCEPTIONS("timeRegulationEnabled")
         break ;
 
       case Message::TIME_CONSTRAINED_ENABLED:
         try {
-            fed_amb->timeConstrainedEnabled(msg->getFedTime());
+            fed_amb->timeConstrainedEnabled(RTIfedTime(msg->getFedTime()));
         }
         CATCH_FEDERATE_AMBASSADOR_EXCEPTIONS("timeConstrainedEnabled")
         break ;
diff -Nru --exclude=CVS --exclude=CMakeFiles certi.orig/libRTI/RTIambPrivateRefs.hh certi/libRTI/RTIambPrivateRefs.hh
--- certi.orig/libRTI/RTIambPrivateRefs.hh	2008-12-07 11:39:03.000000000 +0100
+++ certi/libRTI/RTIambPrivateRefs.hh	2008-12-13 18:04:41.000000000 +0100
@@ -23,6 +23,7 @@
 // ----------------------------------------------------------------------------
 
 #include "RTI.hh"
+#include "fedtime.hh"
 #include "Message.hh"
 #include "RootObject.hh"
 #include "MessageBuffer.hh"
